
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

add_library(
        vga STATIC
        ${CMAKE_CURRENT_LIST_DIR}/pad/serial.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/pce.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/md.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/sfc.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/ps.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/classic.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/pad.c
        ${CMAKE_CURRENT_LIST_DIR}/dac/mcp49x1.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/scc.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/dpcm3.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/sn76489.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/vrc6.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/namcot163.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/ay-3-8910.c
        ${CMAKE_CURRENT_LIST_DIR}/pwm/sn76489.c
        ${CMAKE_CURRENT_LIST_DIR}/vga/vga.c)

set_source_files_properties(
        ${CMAKE_CURRENT_LIST_DIR}/pad/serial.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/pce.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/md.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/sfc.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/ps.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/classic.c
        ${CMAKE_CURRENT_LIST_DIR}/pad/pad.c
        ${CMAKE_CURRENT_LIST_DIR}/dac/mcp49x1.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/scc.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/dpcm3.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/sn76489.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/vrc6.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/namcot163.c
        ${CMAKE_CURRENT_LIST_DIR}/pcm/ay-3-8910.c
        ${CMAKE_CURRENT_LIST_DIR}/pwm/sn76489.c
        ${CMAKE_CURRENT_LIST_DIR}/vga/vga.c
        PROPERTIES COMPILE_FLAGS "-O2 -Wall -Wunused")

target_include_directories(vga PRIVATE ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_BINARY_DIR})

target_link_libraries(vga pico_stdlib pico_multicore hardware_dma hardware_pio hardware_interp hardware_spi hardware_i2c hardware_adc hardware_pwm)

pico_generate_pio_header(vga ${CMAKE_CURRENT_LIST_DIR}/vga/vga.pio)
