' --------------------------------------------------------------------------------
'   ROM C[Wt@CϊXNvg
'
'   Copyright (C) 2022 lsluk, All rights reserved.
'   http://vdmgr.g2.xrea.com/index.html
' --------------------------------------------------------------------------------

    Const NAME_MAX = 22

    Dim m_objFso, m_objShell, m_objStream
    Dim m_aryRomInfo


    If WScript.Arguments.Count = 0 Then
        Call MsgBox("usage: rominfo[.vbs] rominfo.txt", 48, "Help")
        WScript.Quit (2)
    End If

    Set m_objFso = CreateObject("Scripting.FileSystemObject")
    Set m_objShell = WScript.CreateObject("WScript.shell")
    Set m_objStream = WScript.CreateObject("ADODB.Stream")

    m_objShell.CurrentDirectory = m_objFso.GetParentFolderName(WScript.Arguments(0))

    m_aryRomInfo = CreateRomInfo(WScript.Arguments(0))

    Call CreateRomSourceFile(m_aryRomInfo, "rominfo.c")
    Call CreateRomHeaderFile(m_aryRomInfo, "rominfo.h")

    Call MsgBox("t@C쐬܂B", 64, "I")


' --------------------------------------------------------------------------------
'   l 16 i֕̕ϊ
' --------------------------------------------------------------------------------
Function ValueToHexString(nValue, nCount)
    If nCount = 0 Then
        ValueToHexString = "0x" & LCase(Hex(nValue))
    Else
        ValueToHexString = "0x" & Right("0000000" & LCase(Hex(nValue)), nCount)
    End If
End Function


' --------------------------------------------------------------------------------
'   t@C ROM 쐬
' --------------------------------------------------------------------------------
Function CreateRomInfo(strFileName)
    Dim pFile
    Dim aryParam, aryRomInfo()
    Dim strLine, strParam, strName, strRomFileName
    Dim nIndex, nCount, nRomInfoCount, nLine, nCode, nType, nRamSize


    nLine = 1
    nCount = 0

    ReDim aryRomInfo(1000)

    Set pFile = m_objFso.OpenTextFile(strFileName, 1, False)

    Do Until pFile.AtEndOfStream
        strLine = pFile.ReadLine
        nLine = nLine + 1

        nCode = Left(strLine, 1)
        If nCode <> ";" Then

            ' O
            If nCode = """" Then
                nIndex = InStr(2, strLine, """")
                strName = Mid(strLine, 2, nIndex - 2)
                strLine = Mid(strLine, nIndex + 1)
                aryParam = Split(strLine, ",")
            Else
                aryParam = Split(strLine, ",")
                strName = Trim(Replace(aryParam(0), vbTab, ""))
            End If

            If Len(strName) > NAME_MAX Then
                Call MsgBox("line " & nLine & ": O܂", 16, "Fatal Error")
                WScript.Quit 1
            End If

            ' ROM C[Wt@C
            strRomFileName = Trim(Replace(aryParam(1), vbTab, ""))

            ' 
            strParam = Trim(Replace(aryParam(2), vbTab, ""))
            If strParam = "-" Then
                strParam = m_objFso.GetExtensionName(strRomFileName)
            End If

            Select Case LCase(strParam)
                Case "sms"
                    nType = 0

                Case "gg"
                    nType = 1

                Case Else
                    Call MsgBox("line " & nLine & ": ނ܂", 16, "Fatal Error")
                    WScript.Quit 1
            End Select

            ' RAM TCY
            strParam = Trim(Replace(aryParam(3), vbTab, ""))
            If strParam = "-" Then
                nRamSize = 32768
            Else
                nRamSize = CLng(strParam)
            End If

            Set aryRomInfo(nCount) = New CRomInfo
            Call aryRomInfo(nCount).SetParam(strName, strRomFileName, nType, nRamSize)

            nCount = nCount + 1
        End If
    Loop

    pFile.Close

    ReDim Preserve aryRomInfo(nCount - 1)

    CreateRomInfo = aryRomInfo
End Function


' --------------------------------------------------------------------------------
'   ROM 񂩂\[Xt@C쐬
' --------------------------------------------------------------------------------
Function CreateRomSourceFile(aryRomInfo, strFileName)
    Dim pFile
    Dim nIndex, nOffset


    Set pFile = m_objFso.OpenTextFile(strFileName, 2, True)

    Call pFile.Write("#include ""common.h""" & Chr(10))
    Call pFile.Write(Chr(10) & Chr(10))

    ' ROM C[Wf[^
    Call pFile.Write("static const uint8_t" & String(4, vbTab) & "m_romImage[]={")

    nOffset = 0

    For nIndex = 0 To UBound(aryRomInfo)
        nOffset = aryRomInfo(nIndex).WriteRomData(pFile, nOffset)
    Next

    Call pFile.Write(Chr(10) & String(9, vbTab) & "} ;" & Chr(10) & Chr(10))

    ' ROM 񏑂
    pFile.Write ("const ROMINFO" & String(6, vbTab) & "g_romInfo[" & (UBound(aryRomInfo) + 1) & "]={" & Chr(10))

    For nIndex = 0 To UBound(aryRomInfo)
        Call aryRomInfo(nIndex).WriteRomInfo(pFile)
    Next

    Call pFile.Write(String(9, vbTab) & "} ;" & Chr(10))

    pFile.Close
End Function


' --------------------------------------------------------------------------------
'   ROM 񂩂wb_[t@C쐬
' --------------------------------------------------------------------------------
Function CreateRomHeaderFile(aryRomInfo, strFileName)
    Dim pFile
    Dim nIndex, nOffset


    Set pFile = m_objFso.OpenTextFile(strFileName, 2, True)

    Call pFile.Write(Chr(10))
    Call pFile.Write("#ifndef __ROM_H__INCLUDED__" & Chr(10))
    Call pFile.Write("#define __ROM_H__INCLUDED__" & Chr(10))
    Call pFile.Write(Chr(10) & Chr(10))
    Call pFile.Write("extern const ROMINFO" & String(4, vbTab) & "g_romInfo[" & (UBound(aryRomInfo) + 1) & "] ;" & Chr(10))
    Call pFile.Write(Chr(10) & Chr(10))
    Call pFile.Write("#endif//__ROM_H__INCLUDED__" & Chr(10))

    pFile.Close
End Function


' --------------------------------------------------------------------------------
'   ROM 
' --------------------------------------------------------------------------------
Class CRomInfo
    Private m_strName                                           ' O
    Private m_strRomFileName                                    ' ROM C[Wt@C
    Private m_aryRomData                                        ' ROM C[Wf[^
    Private m_nRomDataOffset                                    ' ROM C[Wf[^ItZbg
    Private m_nType                                             ' 
    Private m_nRamSize                                          ' RAM TCY

    ' ----------------------------------------------------------------
    '   oCit@Cǂݍ
    ' ----------------------------------------------------------------
    Private Function LoadBinaryFile(strFileName)
        Dim aryData
        Dim nIndex


        m_objStream.Type = 1
        m_objStream.Open
        m_objStream.LoadFromFile (strFileName)

        ReDim aryData(m_objStream.Size - 1)

        For nIndex = 0 To UBound(aryData)
            aryData(nIndex) = AscB(m_objStream.Read(1))
        Next

        m_objStream.Close

        LoadBinaryFile = aryData
    End Function

    ' ----------------------------------------------------------------
    '   p[^ݒ
    ' ----------------------------------------------------------------
    Public Sub SetParam(strName, strRomFileName, nType, nRamSize)
        m_strName = strName
        m_strRomFileName = strRomFileName
        m_aryRomData = LoadBinaryFile(strRomFileName)
        m_nType = nType
        m_nRamSize = nRamSize
    End Sub

    ' ----------------------------------------------------------------
    '   ROM C[Wf[^t@C֏
    ' ----------------------------------------------------------------
    Public Function WriteRomData(pFile, nOffset)
        Dim nIndex


        Call pFile.Write(Chr(10) & Chr(10) & String(10, vbTab) & "// " & ValueToHexString(nOffset, 0) & "(" & ValueToHexString(UBound(m_aryRomData) + 1, 0) & ")")

        For nIndex = 0 To UBound(m_aryRomData)
            If (nIndex And 15) = 0 Then
                Call pFile.Write(Chr(10) & String(10, vbTab))
            End If

            Call pFile.Write("0x" & Right("0" & LCase(Hex(m_aryRomData(nIndex))), 2) & ",")
        Next

        m_nRomDataOffset = nOffset

        WriteRomData = nOffset + (UBound(m_aryRomData) + 1)
    End Function

    ' ----------------------------------------------------------------
    '   ROM t@C֏
    ' ----------------------------------------------------------------
    Public Sub WriteRomInfo(pFile)
        Call pFile.Write(String(10, vbTab) & "{ ")
        Call pFile.Write("&m_romImage[" & ValueToHexString(m_nRomDataOffset, 6) & "], ")
        Call pFile.Write(ValueToHexString(UBound(m_aryRomData) + 1, 6) & ", ")
        Call pFile.Write(ValueToHexString(m_nRamSize \ 256, 2) & ", ")

        If m_nType = 0 Then
            Call pFile.Write("MODE_SM3, ")
        Else
            Call pFile.Write("MODE_GG,  ")
        End If

        Call pFile.Write("""" & Left(m_strName & String(NAME_MAX, " "), NAME_MAX) & """ }," & Chr(10))
    End Sub
End Class
