// -------------------------------------------------------------------------------- 
//!  @file  enemy.c                                                                 
//!  敵管理のソースファイル                                                         
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#include "common.h"
#include "enemy.h"
#include "enemy00.h"
#include "enemy01.h"
#include "enemy02.h"


// -------------------------------------------------------------------------------- 
//!  敵タスクを生成                                                                 
//!                                                                                 
//!  @param [in] y     ｙ座標                                                       
//!  @param [in] data  データ                                                       
//!  @return なし                                                                   
// -------------------------------------------------------------------------------- 
void RAMFUNC enemy_create(uint8_t y, uint8_t data)
{
	static void (*createProc[])(uint8_t y, uint8_t data)={
					enemy00_create,
					enemy01_create,
					enemy02_create,
				} ;


	createProc[data&15](y, data) ;
}


// -------------------------------------------------------------------------------- 
//!  敵タスクを破棄                                                                 
//!                                                                                 
//!  @param [in,out] p_tcb  タスクコントロールブロック                              
//!  @return                なし                                                    
// -------------------------------------------------------------------------------- 
void RAMFUNC enemy_destroy( TCB *p_tcb )
{
	task_detach( p_tcb ) ;
	task_releaseTcb( p_tcb ) ;
}
