// -------------------------------------------------------------------------------- 
//!  @file  enemy02.c                                                               
//!  敵 02 タスクのソースファイル                                                   
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#include "common.h"
#include "enemy.h"


//static FI8							m_x ;
//static FI8							m_y ;
//static uint8_t						m_angle ;


// -------------------------------------------------------------------------------- 
//!  敵 02 尻尾タスク処理                                                           
//!                                                                                 
//!  @param [in,out] p_tcb  タスクコントロールブロック                              
//!  @return                なし                                                    
// -------------------------------------------------------------------------------- 
void RAMFUNC enemy02_tail( TCB *p_tcb )
{
	TCB		*p_parent ;


	p_parent   = p_tcb->p_parent ;
	p_tcb->x.n = p_parent->x.n + getCos( p_parent->angle ).n ;
	p_tcb->y.n = p_parent->y.n + getSin( p_parent->angle ).n ;

	p_tcb->angle   = p_parent->angle + (getSin( p_tcb->count0 ).n * 5 / FP_ONE)  ;
	p_tcb->count0 += 2 ;

	obj_drawPattern(p_tcb->x.h, p_tcb->y.h, PAT_ENEMY2_8) ;
}


void RAMFUNC enemy02_tail_040( TCB *p_tcb )
{
	TCB		*p_parent ;


	p_parent   = p_tcb->p_parent ;
	p_tcb->x.n = p_parent->x.n + getCos( p_parent->angle ).n ;
	p_tcb->y.n = p_parent->y.n + getSin( p_parent->angle ).n ;

	p_tcb->angle = getAngle(p_tcb->x.h, p_tcb->y.h, g.playerTcb.x.h, g.playerTcb.y.h) ;

	obj_drawPattern(p_tcb->x.h, p_tcb->y.h, PAT_ENEMY2_0+(((p_tcb->angle+16)/32)&7)) ;
}


// -------------------------------------------------------------------------------- 
//!  敵 02 タスク処理                                                               
//!                                                                                 
//!  @param [in,out] p_tcb  タスクコントロールブロック                              
//!  @return                なし                                                    
// -------------------------------------------------------------------------------- 
void RAMFUNC enemy02( TCB *p_tcb )
{
	p_tcb->x.h -= g.bg.xofs ;

//	p_tcb->count0 += p_tcb->count1 ;
//	if( !p_tcb->count0 || (p_tcb->count0==60) ) {
//		p_tcb->count1 = -p_tcb->count1 ;
//	}
//
//	p_tcb->angle  += (getSin( p_tcb->count0 ).n * 5 / FP_ONE)  ;
//	p_tcb->count0 += 2 ;

//	m_angle = 120 + p_tcb->count0 ;
}


// -------------------------------------------------------------------------------- 
//!  敵 02 タスクを生成                                                             
//!                                                                                 
//!  @param [in] y     ｙ座標                                                       
//!  @param [in] data  データ                                                       
//!  @return なし                                                                   
// -------------------------------------------------------------------------------- 
void RAMFUNC enemy02_create(uint8_t y, uint8_t data)
{
	TCB		*p_parent, *p_tcb ;
	int		index ;

	// 根本
	p_parent           = task_getTcb() ;
	p_parent->taskProc = enemy02 ;
	p_parent->angle    = 155 ;
	p_parent->count0   = 0 ;
	p_parent->count1   = 2 ;
	p_parent->x.n      = toFp( 30 + 20 ) ;
	p_parent->y.n      = toFp( 25 ) ;

	task_attachTail(&g.enemyList, p_parent) ;

	// 尻尾
	for(index=0; index<19; index++) {
		p_tcb           = task_getTcb() ;
		p_tcb->p_parent = p_parent ;
		p_tcb->taskProc = enemy02_tail ;
		p_tcb->count0   = index * 8 ;

		task_attachTail(&g.enemyList, p_tcb) ;

		p_parent = p_tcb ;
	}

	// 尻尾先端
	p_tcb           = task_getTcb() ;
	p_tcb->p_parent = p_parent ;
	p_tcb->taskProc = enemy02_tail_040 ;
	p_tcb->count0   = index * 8 ;

	task_attachTail(&g.enemyList, p_tcb) ;
}
